﻿using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using NetflixCatalog.Model;

namespace SFDemo
{
    public class TitleViewModel : INotifyPropertyChanged
    {

        #region Constructor

        public TitleViewModel()
        {
            if (_title == null)
                _title = new Title();
        }

        #endregion

        #region Properties

        public string Name
        {
            get
            {
                return _title.Name;
            }
            set
            {
                if (value != _title.Name)
                {
                    _title.Name = value;
                    NotifyPropertyChanged("Name");
                }
            }
        }

        public string AverageRating
        {
            get
            {
                return _title.AverageRating.ToString();
            }
            set
            {

                _title.AverageRating = Double.Parse(value);
                NotifyPropertyChanged("AverageRating");

            }
        }


        public string Synopsis
        {
            get
            {
                return _title.Synopsis;
            }
            set
            {
                if (value != _title.Synopsis)
                {
                    _title.Synopsis = value;
                    NotifyPropertyChanged("Synopsis");
                }
            }
        }



        public int ReleaseYear
        {
            get
            {
                return (int)_title.ReleaseYear;
            }
            set
            {
                if (value != _title.ReleaseYear)
                {
                    _title.ReleaseYear = value;
                    NotifyPropertyChanged("ReleaseYear");
                }
            }
        }

        public string BoxArtMediumUrl
        {
            get
            {
                return _title.BoxArt.MediumUrl;
            }
            set
            {
                if (value != _title.BoxArt.MediumUrl)
                {
                    _title.BoxArt.MediumUrl = value;
                    NotifyPropertyChanged("BoxArtMediumUrl");
                }
            }
        }

        private Title _title;
        public Title Title
        {
            get
            {
                return _title;
            }
            set
            {
                if (value != _title)
                {
                    _title = value;
                    NotifyPropertyChanged("Item");
                }
            }
        }

        #endregion

        #region INotifyPropertyChanged

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (null != handler)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion

    }
}